import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.*;
class Test extends JFrame implements ActionListener
{
	UIManager.LookAndFeelInfo laf[];
	JButton btn,next;
	JTable table;
	JProgressBar progress;
	Vector cols,data;
	int i=0;
	Test()
	{
		super("LookAndFeel Demo");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setSize(400,400);
		setLocationRelativeTo(null);
		init();
		setVisible(true);
	}
	public void init()
	{
		setLayout(new BorderLayout());

		cols=new Vector();
		data=new Vector();
		cols.add("Sr.No.");
		cols.add("Test Data");

		for(int i=0;i<100;i++)
		{
			Vector v=new Vector();
			v.add(""+i);
			v.add(""+i);
			data.add(v);
		}
		table=new JTable(data,cols);

		add(new JScrollPane(table),BorderLayout.CENTER);

		btn=new JButton("Close");
		next=new JButton("Next");

		JPanel panel=new JPanel();
		panel.add(btn);
		panel.add(next);

		btn.addActionListener(this);
		next.addActionListener(this);

		add(panel,BorderLayout.SOUTH);

		progress=new JProgressBar();
		add(progress,BorderLayout.NORTH);
		new TestThread(progress).start();

		try
		{
			laf=UIManager.getInstalledLookAndFeels();
		}catch(Exception e){}
	}
	public void actionPerformed(ActionEvent ae)
	{
		if(ae.getSource()==btn)
		{
			System.exit(0);
		}
		if(ae.getSource()==next)
		{
			try
			{
				UIManager.setLookAndFeel(laf[i].getClassName());
				SwingUtilities.updateComponentTreeUI(this);
				System.out.println(laf[i++].getClassName());
				if(i>=laf.length)
					i=0;
			}catch(Exception e){}
		}
	}
	public static void main(String args[]) throws Exception
	{
		new Test();
	}
}
class TestThread extends Thread
{
	JProgressBar progress;
	TestThread(JProgressBar progress)
	{
		System.out.println("IN THREAD");
		this.progress=progress;
		progress.setMinimum(0);
		progress.setMaximum(100);
	}
	public void run()
	{
		System.out.println("START");
		try
		{
			while(true)
			{
				progress.setValue(progress.getValue()+1);
				sleep(100);
				if(progress.getValue()>=progress.getMaximum())
					progress.setValue(0);
			}
		}catch(Exception e)
		{
			e.printStackTrace();
		}
		System.out.println("END");
	}
}